//+------------------------------------------------------------------+
//|                                               Daily BreakOut.mq4 |
//|                                                              cja |
//+------------------------------------------------------------------+
#property copyright "cja"

#property indicator_chart_window

extern string UPPER_LINE_______________ ="_____________________________________________";
extern int    LineSTYLE_UPPER        = 0;
extern int    LineWIDTH_UPPER        = 0;
extern color  Line_col_UPPER         = DodgerBlue;
extern string LOWER_LINE_______________ ="_____________________________________________";
extern int    LineSTYLE_LOWER        = 0;
extern int    LineWIDTH_LOWER        = 0;
extern color  Line_col_LOWER         = Red;
extern bool   Extend_Lines           = true;
extern color  Daily_Vertical_col     = CadetBlue; 
extern color  Border_col             = Gray;

extern string UPPER_LINE_2_______________ ="_____________________________________________";
extern int    LineSTYLE_UPPER_2        = 3;
extern int    LineWIDTH_UPPER_2        = 0;
extern color  Line_col_UPPER_2         = DodgerBlue;
extern string LOWER_LINE_2_______________ ="_____________________________________________";
extern int    LineSTYLE_LOWER_2        = 3;
extern int    LineWIDTH_LOWER_2        = 0;
extern color  Line_col_LOWER_2         = Red;

extern int    DaysBack               = 1;// May need to be shifted back to Friday on Monday

#define HI "HI"
#define LO "LO"
#define HI_CURR "HI_CURR"
#define LO_CURR "LO_CURR"

int nDigits;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete(HI); ObjectDelete(LO); ObjectDelete(HI_CURR); ObjectDelete(LO_CURR); 
   
   ObjectDelete("BRK_OUT");ObjectDelete("BRK_OUT1");ObjectDelete("BRK_OUT2");
   ObjectDelete("BRK_OUT3");ObjectDelete("BRK_OUT4");ObjectDelete("BRK_OUT5");
   
   ObjectDelete("Border"); ObjectDelete("Border1");	 ObjectDelete("Border3");
   ObjectDelete("Border4"); ObjectDelete("Border5"); ObjectDelete("Border6");
   ObjectDelete("Border7");ObjectDelete("Border2"); 
   
   ObjectDelete("VERTLINE");ObjectDelete("VERTLINE1");
   
   ObjectDelete("BRK_OUT2T");ObjectDelete("BRK_OUT3T");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
    
                CreateHILO();
}


void CreatePrevHILOW(string HiLow, double start, double end,double s, double w, color clr)
  {
   ObjectCreate(HiLow, OBJ_TREND, 0,iTime(NULL,1440,DaysBack), start,Time[0] , end);
   ObjectSet(HiLow, OBJPROP_COLOR, clr);
   ObjectSet(HiLow,OBJPROP_BACK,true);
   ObjectSet(HiLow,OBJPROP_RAY,Extend_Lines);
   ObjectSet(HiLow,OBJPROP_WIDTH ,w );
   ObjectSet(HiLow,OBJPROP_STYLE,s);
   }
   void DeleteCreatePrevHILOW()
   {
   ObjectDelete(HI); ObjectDelete(LO); 
      }
   void CreateHILO()
   {
   DeleteCreatePrevHILOW(); 
   
  
                  CreateHILOCURR();
}


void CreateCurrentHILOW(string HiLow, double start, double end,double s, double w, color clr)
  {
   ObjectCreate(HiLow, OBJ_TREND, 0,iTime(NULL,1440,0), start,Time[0] , end);
   ObjectSet(HiLow, OBJPROP_COLOR, clr);
   ObjectSet(HiLow,OBJPROP_BACK,true);
   ObjectSet(HiLow,OBJPROP_RAY,Extend_Lines);
   ObjectSet(HiLow,OBJPROP_WIDTH ,w );
   ObjectSet(HiLow,OBJPROP_STYLE,s);
   }
   void DeleteCreateCurrentHILOW()
   {
   ObjectDelete(HI_CURR); ObjectDelete(LO_CURR); 
      }
   void CreateHILOCURR()
   {
   DeleteCreateCurrentHILOW(); 
         
 double highestPrice = iHigh(Symbol(),1440,DaysBack)+8*Point;
 double lowestPrice = iLow(Symbol(),1440,DaysBack)-5*Point;
 
 double HI_Trail = iLow(Symbol(),1440,0)+(highestPrice-lowestPrice);
 double LOW_Trail = iHigh(Symbol(),1440,0)-(highestPrice-lowestPrice);
 
 if(HI_Trail>highestPrice)Line_col_UPPER_2=0;
 if(LOW_Trail<lowestPrice)Line_col_LOWER_2=0;
    
 CreatePrevHILOW(HI,highestPrice,highestPrice,LineSTYLE_UPPER,LineWIDTH_UPPER,Line_col_UPPER);  
 CreatePrevHILOW(LO,lowestPrice,lowestPrice,LineSTYLE_LOWER,LineWIDTH_LOWER,Line_col_LOWER); 
 
 CreateCurrentHILOW(HI_CURR,HI_Trail,HI_Trail,LineSTYLE_UPPER_2,LineWIDTH_UPPER_2,Line_col_UPPER_2);  
 CreateCurrentHILOW(LO_CURR,LOW_Trail,LOW_Trail,LineSTYLE_LOWER_2,LineWIDTH_LOWER_2,Line_col_LOWER_2); 
 

 
  if( StringFind( Symbol(), "JPY", 0) != -1 ) { nDigits  = 2;}
    else                                  { nDigits  = 4; }
    
        
            ObjectDelete("BRK_OUT");	
                ObjectCreate("BRK_OUT", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT","DAILY BreakOut",13, "Tahoma", DarkOrange);
   ObjectSet("BRK_OUT", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT", OBJPROP_YDISTANCE, 26); 
   ObjectSet("BRK_OUT", OBJPROP_BACK,false);
   
            ObjectDelete("BRK_OUT1");	
                ObjectCreate("BRK_OUT1", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT1","**********************",8, "Tahoma", DarkOrange);
   ObjectSet("BRK_OUT1", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT1", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT1", OBJPROP_YDISTANCE, 46); 
   ObjectSet("BRK_OUT1", OBJPROP_BACK,false);
   
             ObjectDelete("BRK_OUT2");	
                ObjectCreate("BRK_OUT2", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT2","Entry High "+DoubleToStr(highestPrice,nDigits),12, "Tahoma", Line_col_UPPER);
   ObjectSet("BRK_OUT2", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT2", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT2", OBJPROP_YDISTANCE, 55);
   ObjectSet("BRK_OUT2", OBJPROP_BACK,false); 
   
               ObjectDelete("BRK_OUT2T");	
                ObjectCreate("BRK_OUT2T", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT2T","Trail High "+DoubleToStr(HI_Trail,nDigits),12, "Tahoma", Line_col_UPPER );
   ObjectSet("BRK_OUT2T", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT2T", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT2T", OBJPROP_YDISTANCE, 75);
   ObjectSet("BRK_OUT2T", OBJPROP_BACK,false); 
   
             ObjectDelete("BRK_OUT3");	
                ObjectCreate("BRK_OUT3", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT3","Entry Low "+DoubleToStr(lowestPrice,nDigits),12, "Tahoma", Line_col_LOWER);
   ObjectSet("BRK_OUT3", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT3", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT3", OBJPROP_YDISTANCE, 100);
   ObjectSet("BRK_OUT3", OBJPROP_BACK,false);  
   
           ObjectDelete("BRK_OUT3T");	
                ObjectCreate("BRK_OUT3T", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT3T","Trail Low "+DoubleToStr(LOW_Trail,nDigits),12, "Tahoma",Line_col_LOWER);
   ObjectSet("BRK_OUT3T", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT3T", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT3T", OBJPROP_YDISTANCE, 120);
   ObjectSet("BRK_OUT3T", OBJPROP_BACK,false); 
   
   
   
             ObjectDelete("BRK_OUT4");	
                ObjectCreate("BRK_OUT4", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT4","Current Price",10, "Tahoma",SlateGray);
   ObjectSet("BRK_OUT4", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT4", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT4", OBJPROP_YDISTANCE, 140);
   ObjectSet("BRK_OUT4", OBJPROP_BACK,false); 
 
   
     double PRICE = NormalizeDouble(MarketInfo(Symbol(),9),nDigits);
   
             ObjectDelete("BRK_OUT5");	
                ObjectCreate("BRK_OUT5", OBJ_LABEL,0, 0, 0);
                ObjectSetText("BRK_OUT5",""+DoubleToStr(PRICE,nDigits),30, "Tahoma",Gold);
   ObjectSet("BRK_OUT5", OBJPROP_CORNER, 0);
   ObjectSet("BRK_OUT5", OBJPROP_XDISTANCE, 30);
   ObjectSet("BRK_OUT5", OBJPROP_YDISTANCE, 152);
   ObjectSet("BRK_OUT5", OBJPROP_BACK,false);
   
    
  
  
 
  //********* Border **************************************************************************
  
               ObjectDelete("Border");	
                ObjectCreate("Border", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border","_________________",12, "Arial Bold", Border_col);
   ObjectSet("Border", OBJPROP_CORNER, 0);
   ObjectSet("Border", OBJPROP_XDISTANCE, 20);
   ObjectSet("Border", OBJPROP_YDISTANCE, 5);
   ObjectSet("Border", OBJPROP_BACK,false); 
   
                ObjectDelete("Border1");	
                ObjectCreate("Border1", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border1","_________________",12, "Arial Bold", Border_col);
   ObjectSet("Border1", OBJPROP_CORNER, 0);
   ObjectSet("Border1", OBJPROP_XDISTANCE, 20);
   ObjectSet("Border1", OBJPROP_YDISTANCE, 185);
   ObjectSet("Border1", OBJPROP_BACK,false); 
   
   
                ObjectDelete("Border2");	
                ObjectCreate("Border2", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border2","____________________",12, "Arial Bold", Border_col);
   ObjectSet("Border2", OBJPROP_CORNER, 0);
   ObjectSet("Border2", OBJPROP_XDISTANCE, 4);
   ObjectSet("Border2", OBJPROP_YDISTANCE, 201); 
   ObjectSet("Border2", OBJPROP_ANGLE, 90);
   ObjectSet("Border2", OBJPROP_BACK,false); 
    
      
   
                ObjectDelete("Border3");	
                ObjectCreate("Border3", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border3","____________________",12, "Arial Bold", Border_col);
   ObjectSet("Border3", OBJPROP_CORNER, 0);
   ObjectSet("Border3", OBJPROP_XDISTANCE, 155);
   ObjectSet("Border3", OBJPROP_YDISTANCE, 201); 
   ObjectSet("Border3", OBJPROP_ANGLE, 90);
   ObjectSet("Border3", OBJPROP_BACK,false); 
   
   
                ObjectDelete("Border4");	
                ObjectCreate("Border4", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border4","---------------------------------",12, "Arial Bold", Border_col);
   ObjectSet("Border4", OBJPROP_CORNER, 0);
   ObjectSet("Border4", OBJPROP_XDISTANCE, 14);
   ObjectSet("Border4", OBJPROP_YDISTANCE, 5);
   ObjectSet("Border4", OBJPROP_BACK,false); 
   
                ObjectDelete("Border5");	
                ObjectCreate("Border5", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border5","---------------------------------",12, "Arial Bold", Border_col);
   ObjectSet("Border5", OBJPROP_CORNER, 0);
   ObjectSet("Border5", OBJPROP_XDISTANCE, 14);
   ObjectSet("Border5", OBJPROP_YDISTANCE, 198);
   ObjectSet("Border5", OBJPROP_BACK,false); 
   
   
                ObjectDelete("Border6");	
                ObjectCreate("Border6", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border6","---------------------------------------",12, "Arial Bold", Border_col);
   ObjectSet("Border6", OBJPROP_CORNER, 0);
   ObjectSet("Border6", OBJPROP_XDISTANCE, 4);
   ObjectSet("Border6", OBJPROP_YDISTANCE, 210); 
   ObjectSet("Border6", OBJPROP_ANGLE, 90);
   ObjectSet("Border6", OBJPROP_BACK,false); 
    
      
   
                ObjectDelete("Border7");	
                ObjectCreate("Border7", OBJ_LABEL,0, 0, 0);
                ObjectSetText("Border7","---------------------------------------",12, "Arial Bold", Border_col);
   ObjectSet("Border7", OBJPROP_CORNER, 0);
   ObjectSet("Border7", OBJPROP_XDISTANCE, 168);
   ObjectSet("Border7", OBJPROP_YDISTANCE, 210); 
   ObjectSet("Border7", OBJPROP_ANGLE, 90);
   ObjectSet("Border7", OBJPROP_BACK,false);
   
   
      ObjectDelete("VERTLINE");
   if(ObjectFind("VERTLINE") != 0) {
   ObjectCreate("VERTLINE", OBJ_VLINE, 0,iTime(NULL,1440,0), iTime(NULL,1440,0));
   ObjectSet("VERTLINE", OBJPROP_COLOR,Daily_Vertical_col );
   ObjectSet("VERTLINE", OBJPROP_STYLE,4);
   ObjectSet("VERTLINE",OBJPROP_BACK,false);
   } else{ ObjectMove("VERTLINE", 0,iTime(NULL,1440,0), iTime(NULL,1440,0));}
   
    
      ObjectDelete("VERTLINE1");
   if(ObjectFind("VERTLINE1") != 0) {
   ObjectCreate("VERTLINE1", OBJ_VLINE, 0,iTime(NULL,1440,DaysBack), iTime(NULL,1440,DaysBack));
   ObjectSet("VERTLINE1", OBJPROP_COLOR,Daily_Vertical_col );
   ObjectSet("VERTLINE1", OBJPROP_STYLE,4);
   ObjectSet("VERTLINE1",OBJPROP_BACK,false);
   } else{ ObjectMove("VERTLINE1", 0,iTime(NULL,1440,DaysBack), iTime(NULL,1440,DaysBack));}
   
  
   
//----
   return(0);
  }
//+------------------------------------------------------------------+